<template>
	<f7-page 
        name="freebies" 
        @page:beforein="onPageBeforeIn"
        @page:beforeout="onPageBeforeOut"
        ptr 
        @ptr:refresh="onPageRefresh"
        infinite
        :infinite-distance="50"
        :infinite-preloader="showPreloader"
        @infinite="loadMore">
		<!-- Top Navbar -->
		<f7-navbar :sliding="false" large title-large="Barang Loak">
			<f7-nav-left back-link></f7-nav-left>
            <f7-nav-title class="show-small-title">{{ currentCategory }}</f7-nav-title>
            <f7-nav-right>
                <f7-link href="/freebies/create/" icon-f7="add" color="smoothgray" icon-only></f7-link>
            </f7-nav-right>
		</f7-navbar>

		<!-- Page content-->
        <f7-block>
			<f7-toolbar tabbar scrollable position="top" no-shadow no-hairlines class="no-background" style="top:0;">
                <f7-link @click="handleFreebiesCategory('semua')" :class="`gradient-box${slugify(currentCategory) == 'semua' ? ' tab-link-active' : ''}`">
					<span class="">Semua</span>									
				</f7-link>
                <f7-link @click="handleFreebiesCategory('barang-saya')" :class="`gradient-box${slugify(currentCategory) == 'barang-saya' ? ' tab-link-active' : ''}`">
					<span class="">Barang Saya</span>									
				</f7-link>
			</f7-toolbar>
		</f7-block>
        <f7-list media-list no-hairlines v-if="!freebiesLoading && freebies.length > 0">
            <f7-list-item
                v-for="(item, index) in freebies"
                :key="index"
                link
                :title="item.author.profile.fullname"
                :subtitle="item.title"
                :text="truncate(stripHTML(item.description))"
                :data-freebie="JSON.stringify(item)"
            >
                <img v-if="item.medias.length > 0" :src="item.medias[0].url.small" width="48" height="48" class="img-circle" slot="media"/>
				<img v-else :src="require('../assets/no-photo.jpg')" width="48" class="img-circle" slot="media">

                <div v-if="currentLocation != null" class="item-after" slot="after-title">
					<f7-icon f7="placemark" size="18px" color="pink"></f7-icon> <span class="distance">{{ distance(currentLocation.latitude, currentLocation.longitude, item.latitude, item.longitude) }}</span>
				</div>
            </f7-list-item>            
        </f7-list>
        <f7-block v-else-if="!freebiesLoading" style="height: calc(100% - 100px)">
			<span class="display-flex align-items-center justify-content-center" style="height:calc(100% - 100px);">
				<span class="text-align-center">
					<span class="display-block text-align-center">
						<f7-icon material="async" style="font-size:100px;color:#eee;margin-left:-100px;"></f7-icon>
						<span class="display-block">It's a little quiet here</span>
					</span>
				</span>
			</span>
		</f7-block>
        <f7-list media-list no-hairlines v-if="freebiesLoading">
            <f7-list-item
                v-for="n in 4"
                :key="n"
                class="skeleton-text skeleton-effect-blink"
                title="Full Name"
                subtitle="Lorem ipsum dolor sit amet"
                after="31 Juli 2019"
                text="Lorem ipsum dolor sit amet, consectetur adipiscing elit. Morbi lobortis et massa ac interdum. Cras consequat felis at consequat hendrerit. Aliquam vestibulum vitae lorem ac iaculis. Praesent nec pharetra massa, at blandit lectus. Sed tincidunt, lectus eu convallis elementum, nibh nisi aliquet urna, nec imperdiet felis sapien at enim."
            >
                <f7-skeleton-block style="width: 48px; height: 48px; border-radius: 50%" slot="media"></f7-skeleton-block>
            </f7-list-item>
        </f7-list>
    </f7-page>
</template>
<script>
import { mapGetters } from 'vuex';
import { hoursAgo, dateFormat, truncate, stripHTML, slugify, distance } from '../js/utils';
import { setTimeout } from 'timers';
export default {
    name: 'Freebies',
    data(){
        return {
            freebiesLoading: true,
            allowInfinite: true,
            showPreloader: true,
            currentCategory: 'Semua'
        };
    },
    computed: {
        ...mapGetters('auth', ['user']),
		...mapGetters('freebies', [
			'freebies',
			'pagination'
        ]),
        currentLocation: function(){
			const self = this;

			let currentLocation = localStorage.getItem('currentLocation') ? JSON.parse(localStorage.getItem('currentLocation')) : null;
			return currentLocation;
		}
    },
    mounted(){
        const self = this;
        const app = self.$f7;
        const $$ = self.$$;

        $$('div[data-name="freebies"]').on('click', '.media-list li', function(){
            let freebie = JSON.parse($$(this).data('freebie'));

            if(freebie.author.id == self.user.id && self.currentCategory == 'Barang Saya'){
                self.showActionSheet(freebie);
            }else{
                self.$f7router.navigate('/freebies/view/'+freebie.id+'/', {
                    ignoreCache: true
                });
            }
        });
    },
    methods: {
        hoursAgo,
        dateFormat,
        truncate,
        stripHTML,
        slugify,
        distance,
        getFreebies(page, loadmore){
			const self = this;
            const app = self.$f7;

            let author = null;

            if(self.currentCategory == 'Barang Saya'){
                author = self.user.id;
            }
            
			self.$store.dispatch('freebies/getFreebies', {
				page: page,
                perpage: 25,
                section: 'page',
                loadmore: loadmore,
                author: author,
                latitude: self.currentLocation != null ? self.currentLocation.latitude : null,
                longitude: self.currentLocation != null ? self.currentLocation.longitude : null,
                only: 'id,title,slug,description,latitude,longitude,created,updated,medias.id,medias.mimetype,medias.url,medias.filename,medias.original_filename,author.id,author.profile,author.profile.fullname,author.profile.initial,author.profile.media'
			}).then(() => {                
                setTimeout(() => {
                    self.freebiesLoading = false;
                    self.showPreloader = self.pagination.has_next;
                }, 100);
            });
		},
        onPageBeforeIn(){
            const self = this;
            const app = self.$f7;

            if(self.currentLocation != null){
				self.getFreebies(1, false);
            }else{
                self.freebiesLoading = false;
                self.showPreloader = false;
            }
        },        
        onPageBeforeOut(page){
            const self = this;

            if(page.detail.name == 'freebies'){
                self.currentCategory = 'Semua';
                self.$store.dispatch('freebies/resetFreebies');
            }
        }, 
        onPageRefresh(e, done){
            const self = this;
            
            self.$store.dispatch('freebies/resetFreebies').then(()=>{
                if(self.currentLocation != null){
                    self.freebiesLoading = true;
                    self.getFreebies(1, false);
                }else{
                    self.freebiesLoading = false;
                    self.showPreloader = false;
                }   
                done();           
            });
        },
        showActionSheet(freebie){
            const self = this;
            const app = self.$f7;

            let buttons = [{
                text: freebie.title,
                label: true
            }, {
                text: 'Lihat',
                close: true,
                onClick: function(actions, e){
                    self.$f7router.navigate('/freebies/view/'+freebie.id+'/', {
                        ignoreCache: true
                    });
                }
            }, {
                text: 'Ubah',
                close: true,
                onClick: function(actions, e){
                    self.$f7router.navigate('/freebies/edit/'+freebie.id+'/', {
                        ignoreCache: true
                    });
                }
            }, {
                text: 'Hapus',
                close: true,
                onClick: function(actions, e){
                    app.dialog.confirm('Anda yakin ingin menghapus barang ini?', function(){
                        app.preloader.show('green');
                        self.$store.dispatch('freebies/deleteFreebie', {
                            id: freebie.id,
                            only: 'id,title,slug,description,latitude,longitude,created,updated,medias.mimetype,medias.url,medias.filename,medias.original_filename,author.id,author.profile,author.profile.fullname,author.profile.initial,author.profile.media'
                        }).then((response)=>{
                            app.preloader.hide();
                            self.$f7router.refreshPage();
                        });
                    });
                }
            }, {
                text: 'Batal',
                color: 'red',
                close: true
            }];

            let actionSheet = app.actions.create({
                buttons: buttons
            }).open();
        },
        loadMore() {
            const self = this;

            if (!self.allowInfinite) return;
            self.allowInfinite = false;

            setTimeout(()=>{
                if(self.pagination.has_next){
                    self.getFreebies(self.pagination.page + 1, true);
                    self.allowInfinite = true;                 
                }else{
                    self.showPreloader = false;
                }
            }, 1000);
        },
        handleFreebiesCategory(category){
			const self = this;
            const app = self.$f7;
            
            self.freebiesLoading = true;
            
            if(category == 'semua'){
                self.currentCategory = 'Semua';
                self.$store.dispatch('freebies/resetFreebies').then(()=>{
                    if(self.currentLocation != null){
                        self.freebiesLoading = true;
                        self.getFreebies(1, false);
                    }else{
                        self.freebiesLoading = false;
                        self.showPreloader = false;
                    }   
                });
            }else{
                self.currentCategory = 'Barang Saya';
                self.$store.dispatch('freebies/resetFreebies').then(()=>{
                    self.getFreebies(1, false);
                });
            }            
		}
    }
}
</script>
